Bug 1468949 - Review Request: python3-greenlet - Lightweight in-process concurrent programming
Review Request: python3-greenlet - Lightweight in-process concurrent programming
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Dominik 'Rathann' Mierzejewski
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2017-07-10 00:33 EDT by Michel Alexandre Salim
Modified: 2017-08-14 02:53 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-08-14 02:53:23 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
dominik: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Michel Alexandre Salim 2017-07-10 00:33:48 EDT
Spec URL: https://salimma.fedorapeople.org/specs/python/python3-greenlet.spec
SRPM URL: https://salimma.fedorapeople.org/specs/python/python3-greenlet-0.4.11-1.el7.centos.src.rpm
Description: Python 3 build of python-greenlet for EPEL7
The greenlet package is a spin-off of Stackless, a version of CPython
that supports micro-threads called "tasklets". Tasklets run
pseudo-concurrently (typically in a single or a few OS-level threads)
and are synchronized with data exchanges on "channels".

Fedora Account System Username: salimma
Comment 1 Michel Alexandre Salim 2017-07-10 00:36:25 EDT
Local mock build and rpmlint:

[michel@lumiere ~]$ ls -l /var/lib/mock/epel-7-x86_64-neovim/result/*.rpm
-rw-rw-r--. 1 michel mock 27560 Jul  9 21:21 /var/lib/mock/epel-7-x86_64-neovim/result/python34-greenlet-0.4.11-1.el7.centos.x86_64.rpm
-rw-rw-r--. 1 michel mock 10024 Jul  9 21:21 /var/lib/mock/epel-7-x86_64-neovim/result/python34-greenlet-devel-0.4.11-1.el7.centos.x86_64.rpm
-rw-rw-r--. 1 michel mock 60749 Jul  9 21:21 /var/lib/mock/epel-7-x86_64-neovim/result/python3-greenlet-0.4.11-1.el7.centos.src.rpm
-rw-rw-r--. 1 michel mock 41000 Jul  9 21:21 /var/lib/mock/epel-7-x86_64-neovim/result/python3-greenlet-debuginfo-0.4.11-1.el7.centos.x86_64.rpm

[michel@lumiere ~]$ rpmlint /var/lib/mock/epel-7-x86_64-neovim/result/*.rpm
python34-greenlet.x86_64: W: spelling-error %description -l en_US tasklets -> task lets, task-lets, skeletal
python34-greenlet.x86_64: W: spelling-error %description -l en_US Tasklets -> Task lets, Task-lets, Skeletal
python3-greenlet.src: W: spelling-error %description -l en_US tasklets -> task lets, task-lets, skeletal
python3-greenlet.src: W: spelling-error %description -l en_US Tasklets -> Task lets, Task-lets, Skeletal
4 packages and 0 specfiles checked; 0 errors, 4 warnings.
Comment 2 Dominik 'Rathann' Mierzejewski 2017-07-10 17:17:06 EDT
Taking review.

One quick comment for now:

Please make use of the python3_pkgversion macro in the file list, too:

%{python3_sitearch}/greenlet.cpython-*.so
%{python3_sitearch}/greenlet*.egg-info
Comment 3 Michel Alexandre Salim 2017-07-10 18:24:58 EDT
(In reply to Dominik 'Rathann' Mierzejewski from comment #2)
> Taking review.
Thanks!

> 
> One quick comment for now:
> 
> Please make use of the python3_pkgversion macro in the file list, too:
> 
> %{python3_sitearch}/greenlet.cpython-*.so
> %{python3_sitearch}/greenlet*.egg-info

This does not seem to be necessary per the draft packaging guidelines for EPEL?
https://fedoraproject.org/wiki/PackagingDrafts:Python3EPEL

on my CentOS 7 box:
❯ rpm -E %{python3_sitearch}
/usr/lib64/python3.4/site-packages
Comment 4 Dominik 'Rathann' Mierzejewski 2017-07-11 14:55:15 EDT
I was thinking about something like this:

%{_includedir}/python%{python3_pkgversion}m/greenlet

%{python3_sitearch}/greenlet.cpython-%{python3_version_nodots}m.so
%{python3_sitearch}/greenlet-%{version}-py%{python3_version}.egg-info
Comment 5 Dominik 'Rathann' Mierzejewski 2017-07-11 14:57:57 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- License: field is incorrect, should be "MIT and Python".
- Missing
  Requires: python%{python3_pkgversion}-libs
  for /usr/include/python3.4m ownership in the
  python34-greenlet-devel subpackage.
- Missing
  Requires: python%{python3_pkgversion}-%{modname}%{?_isa} = %{version}-%{release}
  in the python34-greenlet-devel subpackage.
- You should make use of python3_version and python3_version_nodots
  instead of using wildcards in %files sections.

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[-]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "PSF (v2)", "Unknown or generated". 62
     files have unknown license. Detailed output of licensecheck in
     /home/rathann/build/review/1468949-python3-greenlet/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/include/python3.4m
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[!]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 61440 bytes in 8 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[!]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python34-greenlet , python34-greenlet-devel , python3-greenlet-
     debuginfo
[?]: Package functions as described.
[-]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python34-greenlet-0.4.11-1.el7.centos.x86_64.rpm
          python34-greenlet-devel-0.4.11-1.el7.centos.x86_64.rpm
          python3-greenlet-debuginfo-0.4.11-1.el7.centos.x86_64.rpm
          python3-greenlet-0.4.11-1.el7.centos.src.rpm
python34-greenlet.x86_64: W: spelling-error %description -l en_US tasklets -> task lets, task-lets, skeletal
python34-greenlet.x86_64: W: spelling-error %description -l en_US Tasklets -> Task lets, Task-lets, Skeletal
python3-greenlet.src: W: spelling-error %description -l en_US tasklets -> task lets, task-lets, skeletal
python3-greenlet.src: W: spelling-error %description -l en_US Tasklets -> Task lets, Task-lets, Skeletal
4 packages and 0 specfiles checked; 0 errors, 4 warnings.




Rpmlint (debuginfo)
-------------------
Checking: python3-greenlet-debuginfo-0.4.11-1.el7.centos.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
python3-greenlet-debuginfo.x86_64: W: only-non-binary-in-usr-lib
python34-greenlet.x86_64: W: invalid-url URL: http://pypi.python.org/pypi/greenlet [Errno 104] Connection reset by peer
3 packages and 0 specfiles checked; 0 errors, 2 warnings.



Requires
--------
python3-greenlet-debuginfo (rpmlib, GLIBC filtered):

python34-greenlet (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libpthread.so.0()(64bit)
    libpython3.4m.so.1.0()(64bit)
    python(abi)
    rtld(GNU_HASH)

python34-greenlet-devel (rpmlib, GLIBC filtered):
    python34-greenlet


Provides
--------
python3-greenlet-debuginfo:
    python3-greenlet-debuginfo
    python3-greenlet-debuginfo(x86-64)

python34-greenlet:
    python34-greenlet
    python34-greenlet(x86-64)

python34-greenlet-devel:
    python34-greenlet-devel
    python34-greenlet-devel(x86-64)



Unversioned so-files
--------------------
python34-greenlet: /usr/lib64/python3.4/site-packages/greenlet.cpython-34m.so

Source checksums
----------------
https://github.com/python-greenlet/greenlet/archive/0.4.11.tar.gz :
  CHECKSUM(SHA256) this package     : 66de57ea93ff54f64edc0b235e92d83bb9a4bd8cd69ee325d9300f02547d4320
  CHECKSUM(SHA256) upstream package : 66de57ea93ff54f64edc0b235e92d83bb9a4bd8cd69ee325d9300f02547d4320


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -P Python -m epel-7-x86_64 -b 1468949
Buildroot used: epel-7-x86_64
Active plugins: Python, Generic, Shell-api, C/C++
Disabled plugins: Java, SugarActivity, fonts, Haskell, Ocaml, Perl, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 6 Dominik 'Rathann' Mierzejewski 2017-07-11 15:01:57 EDT
Koji scratch build succeeds: https://koji.fedoraproject.org/koji/taskinfo?taskID=20464322 .
Comment 7 Michel Alexandre Salim 2017-07-12 00:26:53 EDT
Spec URL: https://salimma.fedorapeople.org/specs/python/python3-greenlet.spec
SRPM URL: https://salimma.fedorapeople.org/specs/python/python3-greenlet-0.4.12-1.el7.centos.src.rpm

Fixed all the review comments -- once this is in I'll backport the changes to the main python-greenlet package too.

(In reply to Dominik 'Rathann' Mierzejewski from comment #5)
> Package Review
> ==============
> 
> Legend:
> [x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
> [ ] = Manual review needed
> 
> 
> Issues:
> =======
> - License: field is incorrect, should be "MIT and Python".
Fixed

> - Missing
>   Requires: python%{python3_pkgversion}-libs
>   for /usr/include/python3.4m ownership in the
>   python34-greenlet-devel subpackage.
Fixed -- note: this dependency is actually transitively satisfied through the
base package, but it might be better to be explicit

> - Missing
>   Requires: python%{python3_pkgversion}-%{modname}%{?_isa} =
> %{version}-%{release}
>   in the python34-greenlet-devel subpackage.
Fixed

> - You should make use of python3_version and python3_version_nodots
>   instead of using wildcards in %files sections.
>
Fixed
Comment 8 Dominik 'Rathann' Mierzejewski 2017-07-14 18:32:00 EDT
The package looks good now. I have one final nitpick which you can fix when importing: you have the

%global         modname greenlet

macro, but you don't use it in %prep:

%setup -q -n greenlet-%{version}

or in %files:
%files -n python%{python3_pkgversion}-greenlet
%license LICENSE LICENSE.PSF
%doc AUTHORS NEWS README.rst
%doc doc/greenlet.txt benchmarks
%{python3_sitearch}/greenlet.cpython-%{python3_version_nodots}m.so
%{python3_sitearch}/greenlet-%{version}-py%{python3_version}.egg-info

%files -n python%{python3_pkgversion}-greenlet-devel
%license LICENSE LICENSE.PSF
%doc AUTHORS NEWS README.rst
%{_includedir}/python%{python3_version}m/greenlet

Please use the macro consistently or drop it. Anyway, the package is APPROVED.
Comment 9 Michel Alexandre Salim 2017-07-14 22:12:06 EDT
Thanks Dominik! Will do.
Comment 10 Gwyn Ciesla 2017-07-14 22:23:29 EDT
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/python3-greenlet
Comment 11 Fedora Update System 2017-07-19 22:41:28 EDT
python-neovim-0.1.13-3.el7 python3-greenlet-0.4.12-1.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-3c792bff32
Comment 12 Fedora Update System 2017-07-20 22:49:00 EDT
python-neovim-0.1.13-3.el7, python3-greenlet-0.4.12-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-3c792bff32
Comment 13 Fedora Update System 2017-08-14 02:53:23 EDT
python-neovim-0.1.13-3.el7, python3-greenlet-0.4.12-1.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.